clear all
close all
clc
%addpath('lib/')%add the lib to path when you first use this code


dataset='HCPr900';


spacestr='Ae~At*sqrtT';

%% load, set age range & gender
load(['data_collated/' dataset '.mat'])

load(['data_collated/LobeSegment/' dataset '_LobesExtract_ALL.mat'])
%all matrices in this file are organised as:
%nSubj x nLobe x 2, where nSubj= number of subjects, nLobe=number of lobes,
%The 2nd/3rd/4th/5th/6th columns are Frontal/Parietal/Temporal/Occipital/Insula
%the third dimension is for the two hemispheres of the same subject


eval(['Data=' dataset ';'])


AgeCat=Data.AgeCat;
Gender=categorical(Data.Gender);


%% setup stuff to plot

%this slightly awkward way of reorganising the data is for the gramm plots later
X=[];
Y=[];
LOBE=[];
KCORRECTION=[];


    ids=find(categorical(AgeCat)=='22-25' & Data.AvgCortThickness(:,1)>0 );
    

    %whole hemisphere
    [x,y]=getxy(Data.PialArea(ids,:),Data.SmoothPialArea(ids,:),Data.AvgCortThickness(ids,:),spacestr);
    x=[x(:,1);x(:,2)];
    y=[y(:,1);y(:,2)];
    
    
    Xx = [ones(size(x)) x];
    b = regress(y,Xx);

    lobe=-1*ones(size(y));


    % lobes
    % lobe corr by CHS
    xlcAll=[];ylcAll=[];xlAll=[];ylAll=[];lobel=[];
    MEx=zeros(length(ids)*2,4);
    MEy=MEx;
    for l=2:5
        c=4*pi./K_CHwoBAll(ids,l,:); %correction term

        
        
        %redistribute insular area
        if l<5
            S=sum(TotalAreaAll(ids,2:4,:),2);
            R=TotalAreaAll(ids,l,:)./S;
            TA=TotalAreaAll(ids,l,:)+R.*TotalAreaAll(ids,6,:);
        else
            TA=TotalAreaAll(ids,l,:);
        end

        [xlc,ylc]=getxy(TA.*c,SmoothAreaAll(ids,l,:).*c,AvgThicknessAll(ids,l,:),spacestr);%corrected by curvature


        xlc=[xlc(:,:,1);xlc(:,:,2)];
        ylc=[ylc(:,:,1);ylc(:,:,2)];
        
        MEx(:,l-1)=xlc;
        MEy(:,l-1)=ylc;
        

        xlcAll=[xlcAll;xlc];
        ylcAll=[ylcAll;ylc];
        
        
        [xl,yl]=getxy(TA,SmoothAreaAll(ids,l,:),AvgThicknessAll(ids,l,:),spacestr);%not corrected by curvature
        xl=[xl(:,:,1);xl(:,:,2)];
        yl=[yl(:,:,1);yl(:,:,2)];
        xlAll=[xlAll;xl];
        ylAll=[ylAll;yl];
        lobel=[lobel;(l-1)*ones(size(xlc))];
    end
    
    X=[X;x;xlcAll(:);x;xlAll(:)];
    Y=[Y;y;ylcAll(:);y;ylAll(:)];
    LOBE=[LOBE;lobe;lobel(:);lobe;lobel(:)];%lobe?
    KCORRECTION=[KCORRECTION;lobe*0;lobel(:)*0;lobe*0+1;lobel(:)*0+1];%corrected?

    %% calculate the slopes
    

    slopekk=zeros(size(MEx,1),1);
    for kk=1:size(MEx,1)
        Xkk=[ones(4,1) MEx(kk,:)'];

        S=cov(MEx(kk,:)',MEy(kk,:)');
        u=(2*S(1,1))/sqrt(5*S(1,1)^2 + 2*S(1,1)*S(2,2) + S(2,2)^2);
        Sg = (-S(1,1)^2 + S(1,1)*S(2,2))/(3*S(1,1) + S(2,2));
        Sk = (5*S(1,1)^2 + 2*S(1,1)*S(2,2) + S(2,2)^2)/(3*S(1,1) + S(2,2));
        r=acos(u);
        slope_k=tan(r);
        slopekk(kk)=slope_k;

    end
    
%%

lctmp=cell(size(LOBE));
lctmp(LOBE==-1)={'Hemisphere'};
lctmp(LOBE==1)={'Frontal'};
lctmp(LOBE==2)={'Parietal'};
lctmp(LOBE==3)={'Temporal'};
lctmp(LOBE==4)={'Occipital'};
LOBE=lctmp;

cctmp=cell(size(KCORRECTION));
cctmp(KCORRECTION==1)={'Uncorrected'};
cctmp(KCORRECTION==0)={'Corrected by Gaussian curv'};
KCORRECTION=cctmp;


%% gramm

colordef=[100 100 100; 
    102,194,164; 
    247,104,161; 
    43,140,190; 
    254,153,41]/256;
close all
clear g;
g=gramm('x',X,'y',Y,'color',LOBE);
g.facet_grid(KCORRECTION,ones(size(KCORRECTION)));
g.geom_point('alpha',0.2);
%g.stat_glm();

g.geom_funline('fun',@(x)x-0.5,'style','c--')
g.geom_funline('fun',@(x)x,'style','c--')
g.geom_funline('fun',@(x)x+0.5,'style','c--')
g.geom_funline('fun',@(x)x+1,'style','c--')
g.geom_funline('fun',@(x)x+1.5,'style','c--')
g.geom_funline('fun',@(x)x+2,'style','c--')

g.geom_funline('fun',@(x)b(2)*x+b(1),'style','k-')

g.set_names('row','','column','','x','log_{10}(Ae)','y','log_{10}(At*sqrt(T))','color','Lobe');
g.set_title(dataset);
g.set_color_options('map',colordef)
figure('Position',[0 0 500 800]);
g.draw();

%% plot the slope distribution

figure(2)
histogram(slopekk,0.9:0.03:1.6)
title(['mean=' num2str(mean(slopekk))])