
clear all
close all
clc

%addpath([ 'lib/'])


%as before, uncomment as desired below

% dataset='HCPr900';
% agebounds=[22 26 30 34];%HCP


% dataset='IXI';
% agebounds=[15:10:85];


dataset='NKI';
agebounds=[15:10:85];


% dataset='ADNI';
% agebounds=[55:10:95];



spacestr='Ae~At*sqrtT';


%% set age range & gender
load([ 'data_collated/' dataset '.mat'])

load([ 'data_collated/LobeSegment/' dataset '_LobesExtract_ALL.mat'])

eval(['Data=' dataset ';'])


Age=Data.Age;
% AgeCat=Data.AgeCat;
Gender=categorical(Data.Gender);

d=diff(agebounds);
agecatmid=agebounds(1:end-1)+d(1)/2;



if isfield(Data,'Site')
Site=categorical(Data.Site);
end

if isfield(Data,'Diagnosis')
PatCtrl=categorical(Data.Diagnosis);
PatCtrl=categorical(PatCtrl);
cPatCtrl=categories(PatCtrl);
else
    cPatCtrl=0;
end

%healthy:
mod=Age>0;

if strcmp(dataset,'IXI')
%IXI:
% Site=Data.Site;
mod=Age>0 & categorical(Site)=='Guys';
end

if strcmp(dataset,'ADNI')
%ADNI:
mod=Age>0 & Data.inNonLgt==1;
end

%% setup stuff to plot


OFFSET=[];
THICKNESS=[];
LOBE=[];
KCORRECTION=[];
AGE=[];
AGECAT=[];
GENDER=[];
PATCTRL=[];


for cpc=1:length(cPatCtrl)
    if length(cPatCtrl)>1
        modd=PatCtrl==cPatCtrl{cpc};
    else
        modd=mod;
    end
    for gs=1:3
        for a=1:length(agecatmid)

            if gs==1
            ids=find(Age>=agebounds(a) & Age<agebounds(a+1) & Data.AvgCortThickness(:,1)>0 & Gender=='m' & mod & modd);
            elseif gs==2
            ids=find(Age>=agebounds(a) & Age<agebounds(a+1) & Data.AvgCortThickness(:,1)>0 & Gender=='f' & mod & modd);
            else
            ids=find(Age>=agebounds(a) & Age<agebounds(a+1) & Data.AvgCortThickness(:,1)>0 & mod & modd);
            end

            %whole hemisphere
            [x,y]=getxy(Data.PialArea(ids,:),Data.SmoothPialArea(ids,:),Data.AvgCortThickness(ids,:),spacestr);
            x=[x(:,1);x(:,2)];
            y=[y(:,1);y(:,2)];
            thick=[Data.AvgCortThickness(ids,1);Data.AvgCortThickness(ids,2)];

            offset=y-1.25*x;

            OFFSET=[OFFSET;offset];
            THICKNESS=[THICKNESS;thick];
            LOBE=[LOBE;ones(size(offset))*-1];%lobe
            KCORRECTION=[KCORRECTION;zeros(size(offset))];%corrected?

            AGE=[AGE;Age(ids);Age(ids)];
            AGECAT=[AGECAT;ones(length(ids)*2,1)*agecatmid(a)];
            GENDER=[GENDER;ones(size(offset))*gs];
            PATCTRL=[PATCTRL;ones(size(offset))*cpc];

            % lobe corr by CHS
            for l=2:5
                c=4*pi./K_CHwoBAll(ids,l,:);

                %include insular
                if l<5
                    S=sum(TotalAreaAll(ids,2:4,:),2);
                    R=TotalAreaAll(ids,l,:)./S;
                    TA=TotalAreaAll(ids,l,:)+R.*TotalAreaAll(ids,6,:);
                else
                    TA=TotalAreaAll(ids,l,:);
                end

                [xlc,ylc]=getxy(TA.*c,SmoothAreaAll(ids,l,:).*c,AvgThicknessAll(ids,l,:),spacestr);
                xlc=[xlc(:,:,1);xlc(:,:,2)];
                ylc=[ylc(:,:,1);ylc(:,:,2)];
                thick=[AvgThicknessAll(ids,l,1);AvgThicknessAll(ids,l,2)];

                offset=ylc-1.25*xlc;
                OFFSET=[OFFSET;offset];
                THICKNESS=[THICKNESS;thick];
                LOBE=[LOBE;ones(size(offset))*l-1];%lobe
                KCORRECTION=[KCORRECTION;ones(size(offset))];%corrected?

                AGE=[AGE;Age(ids);Age(ids)];
                AGECAT=[AGECAT;ones(length(ids)*2,1)*agecatmid(a)];
                GENDER=[GENDER;ones(size(offset))*gs];
                PATCTRL=[PATCTRL;ones(size(offset))*cpc];
            end
        end        
    end
    
    
end

    
%%
% 
lctmp=cell(size(LOBE));
lctmp(LOBE==-1)={'Hemisphere'};
lctmp(LOBE==1)={'Frontal lobe'};
lctmp(LOBE==2)={'Parietal lobe'};
lctmp(LOBE==3)={'Temporal lobe'};
lctmp(LOBE==4)={'Occipital lobe'};
LOBE=lctmp;


cctmp=cell(size(GENDER));
cctmp(GENDER==1)={'male'};
cctmp(GENDER==2)={'female'};
cctmp(GENDER==3)={'both'};
GENDER=cctmp;


if cpc>1
cctmp=cell(size(PATCTRL));
cctmp(PATCTRL==1)=cPatCtrl(1);
cctmp(PATCTRL==2)=cPatCtrl(2);
PATCTRL=cctmp;
end


%% plot

close all
clear g
g=gramm('x',AGE,'y',OFFSET,'color',LOBE,'subset',categorical(GENDER)=='both');
g.facet_grid(PATCTRL,[]);
%g.stat_glm();
g.set_names('row','Diagnosis','column','','x','Age','y','Offset','color','Lobe (K corrected)');

g.set_point_options('base_size',7);
g.set_text_options('base_size',12);

np=round(max(AGE)-min(AGE)+1);
g.stat_smooth('npoints',np);

g.set_title(dataset);

g.draw();
